package kdg.bigdata;

import twitter4j.*;
import twitter4j.conf.ConfigurationBuilder;

import java.io.*;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;

import org.apache.log4j.Logger;

/**
 * Created by Jirry on 27/10/2016.
 */
public class ReadTwitter implements Runnable {
    private static Logger logger = Logger.getLogger(ReadTwitter.class.getClass());

    private static final String LANG = "en";
    private static final ConfigurationBuilder cb = new ConfigurationBuilder();

    private String fileName;
    private String outputPath;
    private String[] wordsToFilter;
    private DateFormat dateFormat;
    private DateFormat statusFormat;
    private Date outputDate;

    private FileWriter[] fileWriters;
    private BufferedWriter[] bufferedWriters;
    private PrintWriter[] printWriters;

    public ReadTwitter(String outputPath, String[] wordsToFilter) throws IOException {
        this.wordsToFilter = wordsToFilter;
        this.outputPath = outputPath;

        this.dateFormat = new SimpleDateFormat("yyyMMdd");
        this.statusFormat = new SimpleDateFormat("yyyy/MM/dd");
        this.outputDate = new Date();

        fileWriters = new FileWriter[wordsToFilter.length];
        bufferedWriters = new BufferedWriter[wordsToFilter.length];
        printWriters = new PrintWriter[wordsToFilter.length];

        cb.setDebugEnabled(false)
                .setOAuthConsumerKey("DGUMzB0z04VXdxbotGifjjTPZ")
                .setOAuthConsumerSecret("RMG8BDvjhkGcH4AiV9W4xm0SkYKKU28TQrUbH3JAIvxCpdJOrF")
                .setOAuthAccessToken("50042739-VoX9tsAkfazV5HdkTJoLdTz1OItyxNopEY7t6fOFU")
                .setOAuthAccessTokenSecret("eLjZvHjdIHe4bVEfYurfLAuW2FtQT5IBEE4FZ4MxZYhgG");

        checkIfPathExists();
        makeWriters();
    }

    public void run() {
        twitter4j.TwitterStream twitterStream = new TwitterStreamFactory().getInstance();

        FilterQuery filterQuery = new FilterQuery().track(wordsToFilter);
        twitterStream.addListener(makeListener());
        twitterStream.filter(filterQuery);
    }

    private void makeWriters() throws IOException {
        for (int index = 0; index<wordsToFilter.length; index++){
            fileWriters[index] = new FileWriter(String.format("%s\\%s\\%s.txt", outputPath, wordsToFilter[index],
                                                dateFormat.format(outputDate.getTime())), true);
            bufferedWriters[index] = new BufferedWriter(fileWriters[index]);
            printWriters[index] = new PrintWriter(bufferedWriters[index]);
        }
    }

    private void checkIfPathExists(){
        File pathToCheck;

        for (int index = 0; index<wordsToFilter.length; index++){
            pathToCheck = new File(String.format("%s\\%s", outputPath, wordsToFilter[index]));

            if (!pathToCheck.exists()){
                pathToCheck.mkdir();
            }
        }
    }

    private boolean checkTimeUpdate(Date dateStatus) throws IOException {
        if (!dateFormat.format(outputDate.getTime()).equals(dateFormat.format(dateStatus.getTime()))){
            outputDate = new Date(dateStatus.getTime());
            logger.info("New day, new file (" + statusFormat.format(outputDate.getTime()) + ")");

            for (int index = 0; index<wordsToFilter.length;index++){
                printWriters[index].close();
            }

            makeWriters();
            return  true;
        }

        return  false;
    }

    private StatusListener makeListener(){
        StatusListener tempListener = new StatusListener() {

            public void onStatus(Status status) {
                try {
                    checkTimeUpdate(status.getCreatedAt());
                } catch (IOException e) {
                    logger.error(e);
                    System.out.println("Error: " + e);
                }

                if (status.getLang().equalsIgnoreCase(LANG)){
                    for (int index = 0; index<wordsToFilter.length; index++){
                        if (status.getText().toLowerCase().contains(wordsToFilter[index].toLowerCase())){
                            String outputString = String.format("%s --- %s --- %s\n",
                                    statusFormat.format(status.getCreatedAt()), status.getUser().getName(),
                                    status.getText().replace("\n", " ").replace("\r", " "));
                            System.out.println(String.format("[%s] %s", wordsToFilter[index], outputString));
                            printWriters[index].write(outputString);
                            printWriters[index].flush();
                            break;
                        }
                    }
                }
            }

            public void onDeletionNotice(StatusDeletionNotice statusDeletionNotice) {}

            public void onTrackLimitationNotice(int i) {}

            public void onScrubGeo(long l, long l1) {}

            public void onStallWarning(StallWarning stallWarning) {}

            public void onException(Exception e) {
                logger.error(e);
                System.out.println("Error: " + e);
            }
        };

        return tempListener;
    }
}
